package jp.groupsession.v2.cmn.cmn150;

import java.sql.Connection;
import java.sql.SQLException;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jp.co.sjts.util.NullDefault;
import jp.groupsession.v2.cmn.GSConstLog;
import jp.groupsession.v2.cmn.biz.CommonBiz;
import jp.groupsession.v2.cmn.cmn999.Cmn999Form;
import jp.groupsession.v2.cmn.dao.BaseUserModel;
import jp.groupsession.v2.cmn.model.RequestModel;
import jp.groupsession.v2.struts.AbstractGsAction;
import jp.groupsession.v2.struts.msg.GsMessage;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.util.MessageResources;

/**
 * <br>[機  能] メイン 個人設定 メイン画面表示設定画面のアクションクラス
 * <br>[解  説]
 * <br>[備  考]
 *
 * @author JTS
 */
public class Cmn150Action extends AbstractGsAction {

    /** Logging インスタンス */
    private static Log log__ = LogFactory.getLog(Cmn150Action.class);

    /**
     * <br>アクション実行
     * @param map アクションマッピング
     * @param form アクションフォーム
     * @param req リクエスト
     * @param res レスポンス
     * @param con コネクション
     * @throws Exception 実行例外
     * @return アクションフォーム
     */
    public ActionForward executeAction(ActionMapping map, ActionForm form,
            HttpServletRequest req, HttpServletResponse res, Connection con)
            throws Exception {
        ActionForward forward = null;

        Cmn150Form thisForm = (Cmn150Form) form;
        if (form == null) {
            log__.debug(" form is null ");
        }

        //コマンドパラメータ取得
        String cmd = NullDefault.getString(req.getParameter("CMD"), "");
        if (cmd.equals("cmn150kakunin")) {
            //確認
            forward = __doKakunin(map, thisForm, req, res, con);
        } else if (cmd.equals("cmn150commit")) {
            //登録
            forward = __doCommit(map, thisForm, req, res, con);
        } else if (cmd.equals("cmn150back")) {
            //戻る
            forward = __doBack(map, thisForm, req, res, con);
        } else if (cmd.equals("addArea")) {
            //追加(右矢印)ボタン
            forward = __doAddArea(map, thisForm, req, res, con);
        } else if (cmd.equals("delArea")) {
            //削除(左矢印)ボタン
            forward = __doDelArea(map, thisForm, req, res, con);
        } else if (cmd.equals("upArea")) {
            //地域表示順変更(上矢印)ボタン
            forward = __doUpArea(map, thisForm, req, res, con);

        } else if (cmd.equals("downArea")) {
            //地域表示順変更(下矢印)ボタン
            forward = __doDownArea(map, thisForm, req, res, con);
        } else {
            //デフォルト
            forward = __doInit(map, thisForm, req, res, con);
        }
        return forward;
    }

    /**
     * <br>確認処理
     * @param map アクションマッピング
     * @param form アクションフォーム
     * @param req リクエスト
     * @param res レスポンス
     * @param con コネクション
     * @return アクションフォーワード
     * @throws SQLException SQL実行時例外
     */
    private ActionForward __doKakunin(ActionMapping map, Cmn150Form form,
            HttpServletRequest req, HttpServletResponse res, Connection con)
            throws SQLException {
        log__.debug("確認");

        ActionErrors errors = form.validateCheck(con, req);
        if (!errors.isEmpty()) {
            addErrors(req, errors);
            return __doInit(map, form, req, res, con);
        }

        //トランザクショントークン設定
        saveToken(req);

        //共通メッセージ画面を表示
        __setKakuninPageParam(map, req, form);
        return map.findForward("gf_msg");
    }

    /**
     * <br>[機  能] 確認メッセージ画面遷移時のパラメータを設定
     * <br>[解  説]
     * <br>[備  考]
     * @param map マッピング
     * @param req リクエスト
     * @param form アクションフォーム
     */
    private void __setKakuninPageParam(
        ActionMapping map,
        HttpServletRequest req,
        Cmn150Form form) {


        GsMessage gsMsg = new GsMessage();
        //メイン場面表示設定
        String textMeinDspSetting = gsMsg.getMessage(req, "cmn.setting.main.view2");

        Cmn999Form cmn999Form = new Cmn999Form();

        cmn999Form.setType(Cmn999Form.TYPE_OKCANCEL);
        MessageResources msgRes = getResources(req);
        cmn999Form.setIcon(Cmn999Form.ICON_INFO);
        cmn999Form.setWtarget(Cmn999Form.WTARGET_BODY);
        cmn999Form.setUrlOK(map.findForward("changeOk").getPath());
        cmn999Form.setUrlCancel(map.findForward("changeCancel").getPath());

        //メッセージセット
        String msgState = "edit.kakunin.once";
        String mkey1 = textMeinDspSetting;
        cmn999Form.setMessage(msgRes.getMessage(msgState, mkey1));

        cmn999Form.addHiddenParam("cmn150Dsp1", form.getCmn150Dsp1());
        cmn999Form.addHiddenParam("cmn150Dsp2", form.getCmn150Dsp2());
        cmn999Form.addHiddenParam("cmn150Dsp3", form.getCmn150Dsp3());
        cmn999Form.addHiddenParam("cmn150Dsp4", form.getCmn150Dsp4());
        cmn999Form.addHiddenParam("cmn150Dsp4Area", form.getCmn150Dsp4Area());
        cmn999Form.addHiddenParam("cmn150backPage", form.getCmn150backPage());
        cmn999Form.addHiddenParam("cmn150Dsp5", form.getCmn150Dsp5());
        cmn999Form.addHiddenParam("cmn150Dsp6", form.getCmn150Dsp6());
        req.setAttribute("cmn999Form", cmn999Form);
    }

    /**
     * <br>登録処理
     * @param map アクションマッピング
     * @param form アクションフォーム
     * @param req リクエスト
     * @param res レスポンス
     * @param con コネクション
     * @return アクションフォーワード
     * @throws SQLException SQL実行時例外
     */
    private ActionForward __doCommit(ActionMapping map, Cmn150Form form,
            HttpServletRequest req, HttpServletResponse res, Connection con)
            throws SQLException {
        log__.debug("登録");
        ActionForward forward = null;

        //不正な画面遷移
        if (!isTokenValid(req, true)) {
            log__.info("２重投稿");
            return getSubmitErrorPage(map, req);
        }

        //入力チェック
        ActionErrors errors = form.validateCheck(con, req);
        if (!errors.isEmpty()) {
            addErrors(req, errors);
            return __doInit(map, form, req, res, con);
        }

        //DB更新
        RequestModel reqMdl = getRequestModel(req);
        GsMessage gsMsg = new GsMessage(reqMdl);
        Cmn150Biz biz = new Cmn150Biz(gsMsg);
        BaseUserModel umodel = getSessionUserModel(req);
        Cmn150ParamModel paramModel = new Cmn150ParamModel();
        paramModel.setParam(form);
        biz.setPconfSetting(paramModel, umodel, con);
        paramModel.setFormData(form);

        //ログ出力
        String textEdit = gsMsg.getMessage("cmn.change");
        paramModel.setParam(form);
        String outOpLog = biz.getOpLog(paramModel, con);
        paramModel.setFormData(form);
        CommonBiz cmnBiz = new CommonBiz();
        cmnBiz.outPutCommonLog(map, reqMdl, gsMsg, con,
                textEdit, GSConstLog.LEVEL_INFO,
                outOpLog);

        //共通メッセージ画面(OK)を表示
        __setCompPageParam(map, req, form);
        forward = map.findForward("gf_msg");
        return forward;
    }

    /**
     * <br>[機  能] 完了メッセージ画面遷移時のパラメータを設定
     * <br>[解  説]
     * <br>[備  考]
     * @param map マッピング
     * @param req リクエスト
     * @param form アクションフォーム
     */
    private void __setCompPageParam(
        ActionMapping map,
        HttpServletRequest req,
        Cmn150Form form) {

        Cmn999Form cmn999Form = new Cmn999Form();
        ActionForward urlForward = null;

        cmn999Form.setType(Cmn999Form.TYPE_OK);
        MessageResources msgRes = getResources(req);
        cmn999Form.setIcon(Cmn999Form.ICON_INFO);
        cmn999Form.setWtarget(Cmn999Form.WTARGET_BODY);
        urlForward = __getBackForward(map, form);
        cmn999Form.setUrlOK(urlForward.getPath());

        GsMessage gsMsg = new GsMessage();
        //メイン場面表示設定
        String textMeinDspSetting = gsMsg.getMessage(req, "cmn.setting.main.view2");

        //メッセージセット
        String msgState = "touroku.kanryo.object";
        cmn999Form.setMessage(msgRes.getMessage(msgState, textMeinDspSetting));

        req.setAttribute("cmn999Form", cmn999Form);

    }

    /**
     * <br>戻る処理
     * @param map アクションマッピング
     * @param form アクションフォーム
     * @param req リクエスト
     * @param res レスポンス
     * @param con コネクション
     * @return アクションフォーワード
     * @throws SQLException SQL実行時例外
     */
    private ActionForward __doBack(ActionMapping map, Cmn150Form form,
            HttpServletRequest req, HttpServletResponse res, Connection con)
            throws SQLException {

        log__.debug("戻る");
        return __getBackForward(map, form);
    }

    /**
     * <br>初期表示
     * @param map アクションマッピング
     * @param form アクションフォーム
     * @param req リクエスト
     * @param res レスポンス
     * @param con コネクション
     * @return アクションフォーワード
     * @throws SQLException SQL実行時例外
     */
    private ActionForward __doInit(ActionMapping map, Cmn150Form form,
            HttpServletRequest req, HttpServletResponse res, Connection con)
            throws SQLException {

        log__.debug("初期表示");

        RequestModel reqMdl = getRequestModel(req);
        Cmn150Biz biz = new Cmn150Biz(new GsMessage(reqMdl));
        BaseUserModel umodel = getSessionUserModel(req);
        Cmn150ParamModel paramModel = new Cmn150ParamModel();
        paramModel.setParam(form);
        biz.setInitData(paramModel, umodel, con);
        paramModel.setFormData(form);

        return map.getInputForward();
    }

    /**
     * <br>[機  能] 追加(右矢印)ボタンクリック時処理を行う
     * <br>[解  説]
     * <br>[備  考]
     * @param map アクションマッピング
     * @param form アクションフォーム
     * @param req リクエスト
     * @param res レスポンス
     * @param con コネクション
     * @throws SQLException SQL実行例外
     * @return ActionForward
     */
    private ActionForward __doAddArea(
        ActionMapping map,
        Cmn150Form form,
        HttpServletRequest req,
        HttpServletResponse res,
        Connection con) throws SQLException {

        CommonBiz cmnBiz = new CommonBiz();
        form.setCmn150Dsp4Area(
                    cmnBiz.getAddMember(form.getCmn150Dsp4AreaRight(),
                                        form.getCmn150Dsp4Area()));

        return  __doInit(map, form, req, res, con);
    }

    /**
     * <br>[機  能] 削除(左矢印)ボタンクリック時処理を行う
     * <br>[解  説]
     * <br>[備  考]
     * @param map アクションマッピング
     * @param form アクションフォーム
     * @param req リクエスト
     * @param res レスポンス
     * @param con コネクション
     * @throws SQLException SQL実行例外
     * @return ActionForward
     */
    private ActionForward __doDelArea(
        ActionMapping map,
        Cmn150Form form,
        HttpServletRequest req,
        HttpServletResponse res,
        Connection con) throws SQLException {

        CommonBiz cmnBiz = new CommonBiz();
        form.setCmn150Dsp4Area(
                cmnBiz.getDeleteMember(form.getCmn150Dsp4AreaLeft(),
                                    form.getCmn150Dsp4Area()));

        return __doInit(map, form, req, res, con);
    }

    /**
     * <br>[機  能] 地域表示順変更(上矢印)ボタンクリック時処理を行う
     * <br>[解  説]
     * <br>[備  考]
     * @param map アクションマッピング
     * @param form アクションフォーム
     * @param req リクエスト
     * @param res レスポンス
     * @param con コネクション
     * @throws SQLException SQL実行例外
     * @return ActionForward
     */
    private ActionForward __doUpArea(
        ActionMapping map,
        Cmn150Form form,
        HttpServletRequest req,
        HttpServletResponse res,
        Connection con) throws SQLException {

        Cmn150Biz biz = new Cmn150Biz(new GsMessage(req));
        form.setCmn150Dsp4Area(
                    biz.getUpArea(form.getCmn150Dsp4Area(),
                                form.getCmn150Dsp4AreaLeft()));

        return  __doInit(map, form, req, res, con);
    }

    /**
     * <br>[機  能] 地域表示順変更(下矢印)ボタンクリック時処理を行う
     * <br>[解  説]
     * <br>[備  考]
     * @param map アクションマッピング
     * @param form アクションフォーム
     * @param req リクエスト
     * @param res レスポンス
     * @param con コネクション
     * @throws SQLException SQL実行例外
     * @return ActionForward
     */
    private ActionForward __doDownArea(
        ActionMapping map,
        Cmn150Form form,
        HttpServletRequest req,
        HttpServletResponse res,
        Connection con) throws SQLException {

        Cmn150Biz biz = new Cmn150Biz(new GsMessage(req));
        form.setCmn150Dsp4Area(
                biz.getDownArea(form.getCmn150Dsp4Area(),
                                form.getCmn150Dsp4AreaLeft()));

        return __doInit(map, form, req, res, con);
    }

    /**
     * <br>[機  能] 戻り先画面を取得する
     * <br>[解  説]
     * <br>[備  考]
     * @param map ActionMapping
     * @param form フォーム
     * @return 戻り先画面
     */
    private ActionForward __getBackForward(ActionMapping map, Cmn150Form form) {
        ActionForward forward = map.findForward("cmn150back");
        if (form.getCmn150backPage() == Cmn150Form.BACKPAGE_MAIN) {
            forward = map.findForward("cmn150backMainPage");
        }

        return forward;
    }
}
